
% startup file for diff drive problem


% clear the workspace
clear

% load the standard stuff, like kf methods
startup

% load the problem structure
basic_problem;


% noise settings for environment
% true process noise
problem.env.process.noise.value = [0; 0; 0];
problem.env.process.noise.uncert = [0,0,0; 0,0,0; 0,0,0];

% true measurement noise
problem.env.meas.noise.value = [0; 0; 0];
problem.env.meas.noise.uncert = [0,0,0; 0,0,0; 0,0,0];

% initial true state and uncertainty
problem.env.state.value = [0; 0; 0]; % latest step result
problem.env.state.uncert = [1^2, 0,0; 0,1^2,0; 0,0,1^2]; 


% KF process noise
problem.model.process.noise.value = [0; 0; 0]; % zero mean noise
problem.model.process.noise.uncert = [0.5, 0, 0; 0, 5, 0; 0,0, 50];   % with some independent noise


% KF measurement noise
problem.model.meas.noise.value = [0; 0; 0];
problem.model.meas.noise.uncert = [0.5, 0, 0; 0, 0.5,0; 0,0, 0.5];


% initial KF state and uncertainty
problem.model.state_est.value = problem.env.state.value;  
problem.model.state_est.uncert = problem.env.state.uncert; 


% set up the control parameters
global control_para;
control_para.straight_steps = 0;
control_para.length = 200;
control_para.distance_step_size = 10;
control_para.turn_step_size = 0.25*2*pi;


global meas_counter;
meas_counter = 0;



  