function [figures, kf_data] = charts_estimate(data, kf_data, figures)

	% display charts for estimates plus true data
    error('function is not up-to-date.');
    
    % true plus prior state trajectories
    figures.true_plus_prior_state_trajectories = figure;
            
    arr_source1 = data.process;
    arr_source2 = kf_data.x_prior;
    
    [r c] = size(arr_source1);
    state_size = c-1;
    real_state_size = state_size; %for later use in uncertainties..
    
    fig_width = 1;
    fig_height = state_size;
    
    
    for i=1:state_size
    
    
	    % display data of element i
	    figures.true_plus_prior_state_trajectory(i) = subplot(fig_height,fig_width,i);
        
        hold on;
	    plot(arr_source1(:,1),arr_source1(:,i+1),':');
        plot(arr_source2(:,1),arr_source2(:,i+1),'-');
        
    	xlabel 'step';
    	ylabel 'value';
    	title (['true and estimated trajectory prior state element ',num2str(i)]);
	
    end
    
    
	
    % true and posterior state trajectories
    figures.true_plus_post_state_trajectories = figure;
            
    arr_source1 = data.process;
    arr_source2 = kf_data.x_post;
    
    [r c] = size(arr_source1);
    state_size = c-1;
    
    fig_width = 1;
    fig_height = state_size;
    
    
    for i=1:state_size
    
    
	    % display data of element i
	    figures.true_plus_post_state_trajectory(i) = subplot(fig_height,fig_width,i);
        
        hold on;
        plot(arr_source1(:,1),arr_source1(:,i+1),':')
    	plot(arr_source2(:,1),arr_source2(:,i+1),'-')
    	xlabel 'step';
    	ylabel 'value';
    	title (['true and estimated trajectory post state element ',num2str(i)]);
	
    end
    
    
    % true and posterior state trajectories
    figures.true_plus_est_meas_trajectories = figure;
            
    arr_source1 = data.meas;
    arr_source2 = kf_data.z_hat;
    
    [r c] = size(arr_source1);
    state_size = c-1;
    
    fig_width = 1;
    fig_height = state_size;
    
    
    for i=1:state_size
    
    
	    % display data of element i
	    figures.true_plus_est_meas_trajectory(i) = subplot(fig_height,fig_width,i);
        
        hold on;
        plot(arr_source1(:,1),arr_source1(:,i+1),'bx')
    	plot(arr_source2(:,1),arr_source2(:,i+1),'ro')
    	xlabel 'step';
    	ylabel 'value';
    	title (['true (bx) and estimated (ro) trajectory meas element ',num2str(i)]);
	
    end
    
    
    % true and posterior state trajectories plus posterior states
    figures.true_plus_est_meas_plus_post_state_trajectories = figure;
            
    arr_source1 = data.meas;
    arr_source2 = kf_data.z_hat;
    arr_source3 = kf_data.x_post;
    arr_source4 = kf_data.x_prior;
    arr_source5 = data.process;
    
    [r c] = size(arr_source1);
    state_size = c-1;
    
    fig_width = 1;
    fig_height = state_size;
    
    
    for i=1:state_size
    
    
	    % display data of element i
	    figures.true_plus_est_meas_plus_post_state_trajectory(i) = subplot(fig_height,fig_width,i);
        
        hold on;
        plot(arr_source1(:,1),arr_source1(:,i+1),'bx');
    	plot(arr_source2(:,1),arr_source2(:,i+1),'ro');
        plot(arr_source3(:,1),arr_source3(:,i+1));
        plot(arr_source4(:,1),arr_source4(:,i+1),'r:');
        plot(arr_source5(:,1),arr_source5(:,i+1),'b:');
    	xlabel 'step';
    	ylabel 'value';
    	title (['meas: true (bx); estimated (ro); state: true(b); prior (r); post (-), el. ',num2str(i)]);
	
    end
    
    
    
    % compute error
    kf_data.prior_mse = data.process - kf_data.x_prior;
    kf_data.prior_mse(:,1) = data.process(:,1);
    
    kf_data.post_mse = data.process - kf_data.x_post;
    kf_data.post_mse(:,1) = data.process(:,1);
    
    
    % display prior mse
    figures.prior_mse = figure;
            
    arr_source1 = kf_data.prior_mse;
    
    [r c] = size(arr_source1);
    state_size = c-1;
    
    fig_width = 1;
    fig_height = state_size;
    
    
    for i=1:state_size
    
    
	    % display data of element i
	    figures.prior_mse_trajectory(i) = subplot(fig_height,fig_width,i);
        
        hold on;
        plot(arr_source1(:,1),arr_source1(:,i+1),'-')
    	%plot(arr_source2(:,1),arr_source2(:,i+1),'-')
    	xlabel 'step';
    	ylabel 'value';
    	title (['difference between true and estimated prior state trajectory element ',num2str(i)]);
	
    end
    
    
    % display post mse
    figures.post_mse = figure;
            
    arr_source1 = kf_data.post_mse;
    
    [r c] = size(arr_source1);
    state_size = c-1;
    
    fig_width = 1;
    fig_height = state_size;
    
    
    for i=1:state_size
    
    
	    % display data of element i
	    figures.post_mse_trajectory(i) = subplot(fig_height,fig_width,i);
        
        hold on;
        plot(arr_source1(:,1),arr_source1(:,i+1),'-')
    	%plot(arr_source2(:,1),arr_source2(:,i+1),'-')
    	xlabel 'step';
    	ylabel 'value';
    	title (['difference between true and estimated posterior state trajectory element ',num2str(i)]);
	
    end
    