function [figur] = charts_true_multi(true_data, conv_meas,hold_on,style)
% conv_meas indicates if measurements should be converted before display

	% display charts for different variables
   	if nargin < 2,
        disp 'plots multiple true variables in one plot';
        disp 'syntax: figures = charts_true_multi(true_data, convert_measurements, hold_last_figure, true_line_style)';
        error('not enough parameters');
    elseif nargin == 2,
        hold_on = 0;
        style = '-';        
    end;
    
    
    if (~(hold_on==1)), % create new picture?
        figure;
    else
        hold on;  % or continue in old?
    end;
    
    % source array:
    arr = true_data.process;
    
    titl = 'true x,y trajectory with measurements';
    
    % variable:
    var1 = 2; name1 = 'x(cm)';
    var2 = 3; name2 = 'y(cm)';
    
    % style
    %style = '-';
    
	% nr of subplots:
    fig_width = 1;
    fig_height = 1;
           
	% display estimated path with true measurements
	figures.true_traj = subplot(fig_width,fig_height,1);
	plot(arr(:,var1),arr(:,var2),style,'MarkerSize',5);
	xlabel (name1);
	ylabel (name2);
	title (titl);
	
	
    hold on;
	
	% add true measurements
    % nb: measurements are relative to the robots position
    % so, we add the estimate position of the robot, to get
    % the total estimated location of where the robot expects
    % the landmark to be..
    [meas_dat arr_uncert] = convert_step_data_2_arr(true_data.meas);
    [proc_dat] = expand_process(true_data.process, meas_dat);
    
    
    if conv_meas == 1,
        test = diff_drive_convert_rel_meas_to_abs(proc_dat, meas_dat);
    else
        test = meas_dat;
    end;
    
    plot(test(:,2),test(:,3),'bx');
   
  
    	
    
    