function [] = diff_drive_charts_animate(data, kf_data, figures)
% diff_drive_charts_animate(data, kf_data, figures)
% shows in animation the results of the KF
% displays the uncertainties in x and y
% first display prior state estimate
% then if there is a measurement, 
%   displays the measurement
%   and displays the posterior state estimate


  	%add numbers
	[m n] = size(kf_data.x_prior(:,2));
	%text(ekf.x_post(1,2),ekf.x_post(1,3),num2str(1));
	for i=1:1:m,
        
        disp 'press a key..';
        pause;
	
        % make arrow with step number in state trajectory
        figure(figures.main);
               
        subplot(figures.estim_traj);
        text(kf_data.x_prior(i,2),kf_data.x_prior(i,3),['\bullet']);
        
        % also draw ellipse around state
        draw_ellipse( [kf_data.x_prior(i,2); kf_data.x_prior(i,3)], [kf_data.c_x_prior(i,2), kf_data.c_x_prior(i,3); kf_data.c_x_prior(i,5),  kf_data.c_x_prior(i,6)]);
	    
        
        % plot the gaussian in the gaussian display
        subplot(figures.fig_uncert_x_y_gauss);
        [g_x,g_y,g_z] = draw_gauss_3d( [ kf_data.x_prior(i,2); kf_data.x_prior(i,3)], [kf_data.c_x_prior(i,2), kf_data.c_x_prior(i,3); kf_data.c_x_prior(i,5),  kf_data.c_x_prior(i,6)], [ kf_data.x_prior(i,2); kf_data.x_prior(i,3)] - [20;20],[ kf_data.x_prior(i,2); kf_data.x_prior(i,3)] + [20;20],[1;1]);
	
        hold on;
        surfc(g_x,g_y,g_z)
        %shading interp
        
        % and add text with step number
        text(kf_data.x_prior(i,2), kf_data.x_prior(i,3), 0, ['k=' num2str(i) ]);
        
        
        % if there is a measurement, display it in Gaussian window
        if ~isnan(kf_data.z_res(i,2)),
            
            disp 'measurement incoming, press key to show true measurement';
            pause;
            
            [g_x,g_y,g_z] = draw_gauss_3d( [ data.meas(i,2); data.meas(i,3)], [data.C_meas(i,2), data.C_meas(i,3); data.C_meas(i,5), data.C_meas(i,6)], [ data.meas(i,2); data.meas(i,3)] - [20;20],[ data.meas(i,2); data.meas(i,3)] + [20;20],[1;1]);
	
            % hold on;
            surfc(g_x,g_y,g_z)
            %shading interp
            text(data.meas(i,2), data.meas(i,3), 0, ['true meas: k=' num2str(i) ]);
            
            
            
            disp 'press key to show prediction';
            pause;
 
            % note: displaying measurement prediction!
            % note: uncertainty is same as residual uncertainty
            [g_x,g_y,g_z] = draw_gauss_3d( [ kf_data.z_hat(i,2); kf_data.z_hat(i,3)], [kf_data.C_z_hat(i,2), kf_data.C_z_hat(i,3); kf_data.C_z_hat(i,5), kf_data.C_z_hat(i,6)], [ kf_data.z_hat(i,2); kf_data.z_hat(i,3)] - [20;20],[ kf_data.z_hat(i,2); kf_data.z_hat(i,3)] + [20;20],[1;1]);
	
            % hold on;
            surfc(g_x,g_y,g_z)
            %shading interp
            text(kf_data.z_hat(i,2), kf_data.z_hat(i,3), 0, ['pred meas: k=' num2str(i) ]);
            
            
            
            disp 'press key for posterior estimate';
            pause;
 
            % display posterior state estimate
            [g_x,g_y,g_z] = draw_gauss_3d( [ kf_data.x_post(i,2); kf_data.x_post(i,3)], [kf_data.c_x_post(i,2), kf_data.c_x_post(i,3); kf_data.c_x_post(i,5),  kf_data.c_x_post(i,6)], [ kf_data.x_post(i,2); kf_data.x_post(i,3)] - [20;20],[ kf_data.x_post(i,2); kf_data.x_post(i,3)] + [20;20],[1;1]);
	        
            % hold on;
            surfc(g_x,g_y,g_z)
            %shading interp
            text(kf_data.z_hat(i,2), kf_data.z_hat(i,3), 0, ['post: k=' num2str(i) ]);
           
        end;
        
        
        
        
        
        
        % update the uncertainty markers
        figure(figures.uncertainties);
        
        subplot(figures.fig_uncert_x);
        text(kf_data.c_x_post(i,1),kf_data.c_x_post(i,2),'x');
        
        subplot(figures.fig_uncert_y);
        text(kf_data.c_x_post(i,1),kf_data.c_x_post(i,6),'x');
       
        subplot(figures.fig_uncert_phi);
        text(kf_data.c_x_post(i,1),kf_data.c_x_post(i,10),'x');
       
	end;
