
clear('data_b');

max = 50;

% for i = 1:max
%     disp([num2str(i),' of ',num2str(max)]);
%     
%     diff_drive_reinit_fs;
%     steps = 220;
%     [data_b(i)] = run_x_cycles(problem, kf_method(3), steps, 2,[] ,1);
% end;

for i = 1:max
    disp([num2str(i),' of ',num2str(max)]);
    
    diff_drive_reinit_fs;
    steps = 220;
    update_meas;
    [data_b(i)] = run_kf_on_data(problem, kf_method(3), data, 1);
end;
 
disp('displaying result..');
hold off;
figures.est_prior_state_trajectories = figure
hold on;
max = 15;
for i = 1:max,
        % combine prior and posterior data
       
       
    [res] = combine_prior_and_post_error(data,data_b(i));
    [z_hat_val z_hat_uncert] = convert_step_data_2_arr(data_b(i).z_hat);
   
    [ty to] = size(res);
   
    % mixed prior and posterior state trajectories
   % figures.est_prior_state_trajectories = figure;
   % hold on;
    
    %[prior_val prior_uncert] = convert_step_data_2_arr(kf_data.x_prior);
    %arr_source = prior_val;
    
   
    [r c] = size(res(1).value.from);
    state_size = c-1;
    real_state_size = state_size; %for later use in uncertainties..
    
    fig_width = 1;
    fig_height = 1; %state_size;
    
    
    for i=1:1 %state_size
    
         var1 = 1;
         var2 = i+1;
   
        % display data of element i
	    figures.est_prior_state_trajectory(i) = subplot(fig_height,fig_width,i);
        hold on;
        
        for k = 1:to-1, 
            tmp_data(1,1) = res(k).value.from(1,var1);
            tmp_data(1,2) = res(k).value.from(1,var2);
            tmp_data(2,1) = res(k).value.to(1,var1);
            tmp_data(2,2) = res(k).value.to(1,var2);
        
        
            % if there was a measurement, then there was a correction
            % otherwise it was copying the prior
            if (isnan(z_hat_val(k,2))),
                plot(tmp_data(:,1), tmp_data(:,2),'b:');    % copying
            else
                plot(tmp_data(:,1), tmp_data(:,2),'r:');    % correction
            end;
        
            tmp_data(1,1) = tmp_data(2,1);
            tmp_data(1,2) = tmp_data(2,2);
            tmp_data(2,1) = res(k+1).value.from(1,var1);
            tmp_data(2,2) = res(k+1).value.from(1,var2);
        
            plot(tmp_data(:,1), tmp_data(:,2),'b:');
            
            
        
        end;
       
        
	    var1 = 1;
        var2 = i+1+(i-1)*3;
   
        % display data of element i
	    hold on;
        
        for k = 1:to-1, 
            tmp_data(1,1) = res(k).uncert.from(1,var1);
            tmp_data(1,2) = 2*sqrt(res(k).uncert.from(1,var2));
            tmp_data(2,1) = res(k).uncert.to(1,var1);
            tmp_data(2,2) = 2*sqrt(res(k).uncert.to(1,var2));
        
        
            % if there was a measurement, then there was a correction
            % otherwise it was copying the prior
            if (isnan(z_hat_val(k,2))),
                plot(tmp_data(:,1), tmp_data(:,2),'b-');    % copying
            else
                plot(tmp_data(:,1), tmp_data(:,2),'r-');    % correction
            end;
        
            tmp_data(1,1) = tmp_data(2,1);
            tmp_data(1,2) = tmp_data(2,2);
            tmp_data(2,1) = res(k+1).uncert.from(1,var1);
            tmp_data(2,2) = 2*sqrt(res(k+1).uncert.from(1,var2));
        
            plot(tmp_data(:,1), tmp_data(:,2),'b-');
            
            tmp_data(1,1) = res(k).uncert.from(1,var1);
            tmp_data(1,2) = -2*sqrt(res(k).uncert.from(1,var2));
            tmp_data(2,1) = res(k).uncert.to(1,var1);
            tmp_data(2,2) = -2*sqrt(res(k).uncert.to(1,var2));
        
        
            % if there was a measurement, then there was a correction
            % otherwise it was copying the prior
            if (isnan(z_hat_val(k,2))),
                plot(tmp_data(:,1), tmp_data(:,2),'b-');    % copying
            else
                plot(tmp_data(:,1), tmp_data(:,2),'r-');    % correction
            end;
        
            tmp_data(1,1) = tmp_data(2,1);
            tmp_data(1,2) = tmp_data(2,2);
            tmp_data(2,1) = res(k+1).uncert.from(1,var1);
            tmp_data(2,2) = -2*sqrt(res(k+1).uncert.from(1,var2));
        
            plot(tmp_data(:,1), tmp_data(:,2),'b-');
                        tmp_data(1,1) = res(k).uncert.from(1,var1);
            tmp_data(1,2) = 2*sqrt(res(k).uncert.from(1,var2));
            tmp_data(2,1) = res(k).uncert.to(1,var1);
            tmp_data(2,2) = 2*sqrt(res(k).uncert.to(1,var2));
        
        
            % if there was a measurement, then there was a correction
            % otherwise it was copying the prior
            if (isnan(z_hat_val(k,2))),
                plot(tmp_data(:,1), tmp_data(:,2),'b-');    % copying
            else
                plot(tmp_data(:,1), tmp_data(:,2),'r-');    % correction
            end;
        
            tmp_data(1,1) = tmp_data(2,1);
            tmp_data(1,2) = tmp_data(2,2);
            tmp_data(2,1) = res(k+1).uncert.from(1,var1);
            tmp_data(2,2) = 2.576*sqrt(res(k+1).uncert.from(1,var2));
        
            plot(tmp_data(:,1), tmp_data(:,2),'b-');
            
            tmp_data(1,1) = res(k).uncert.from(1,var1);
            tmp_data(1,2) = -2.576*sqrt(res(k).uncert.from(1,var2));
            tmp_data(2,1) = res(k).uncert.to(1,var1);
            tmp_data(2,2) = -2.576*sqrt(res(k).uncert.to(1,var2));
        
        
            % if there was a measurement, then there was a correction
            % otherwise it was copying the prior
            if (isnan(z_hat_val(k,2))),
                plot(tmp_data(:,1), tmp_data(:,2),'b-');    % copying
            else
                plot(tmp_data(:,1), tmp_data(:,2),'r-');    % correction
            end;
        
            tmp_data(1,1) = tmp_data(2,1);
            tmp_data(1,2) = tmp_data(2,2);
            tmp_data(2,1) = res(k+1).uncert.from(1,var1);
            tmp_data(2,2) = -2.576*sqrt(res(k+1).uncert.from(1,var2));
        
            plot(tmp_data(:,1), tmp_data(:,2),'b-');
            
        end;

	   % plot(arr_source(:,1),arr_source(:,i+1))
    	xlabel 'step';
    	ylabel 'value';
    	title (['prediction and correction error plus uncertainties, element ',num2str(i)]);
	
    end
    
    
       
   
end;