function [z_real] = diff_drive_get_real_failing_measurement(x_real, R_real)
% returns 'real' measurement, given state x_real

    % x_real is expected to be [x v]'
   
   
    global meas_counter;
    global steps_per_measurement;
    global start_failing_from; % indicates step from which sensor starts failing
    global fail_prob; % indicates percentage of extreme values
    
    
    % policy for deciding if measurement should be given:
    % every 5 steps
    if meas_counter>=steps_per_measurement,
        meas_counter = 0;
        give_measurement = 1;
    else
        meas_counter = meas_counter + 1;
        give_measurement = 0;
    end
   
  %  if rand>-1, give_measurement = 0;
  %  else
 %       give_measurement = 1;
 %   end;
    
    
    % z is measurement, in this case full state estimate
    
    if give_measurement==1,
        z_real.value(1,1) = x_real.value(1,1);
        z_real.value(2,1) = x_real.value(2,1);
        z_real.value(3,1) = x_real.value(3,1);
   
        % add Gaussian noise
        [m n] = size(R_real.uncert);
        for i=1:m, z_real.value(i,1) = z_real.value(i,1) + sqrt(R_real.uncert(i,i))*randn; end;
        
                
        % copy uncertainty
        for i=1:m, for j=1:m, z_real.uncert(i,j) = R_real.uncert(i,j); end; end;
        
        if rand>fail_prob,
            z_real.value(1,1) = rand*sqrt(R_real.uncert(3,3))*x_real.value(1,1);
            z_real.value(2,1) = rand*sqrt(R_real.uncert(3,3))*x_real.value(2,1);
            z_real.value(3,1) = rand*sqrt(R_real.uncert(3,3))*x_real.value(3,1);
        end;
 
    else
        z_real.value(1,1) = NaN;
        z_real.value(2,1) = NaN;
        z_real.value(3,1) = NaN;
        
        [m n] = size(R_real.uncert);
        
        % copy uncertainty
        for i=1:m, for j=1:m, z_real.uncert(i,j) = NaN; end; end;

    end;
    
   % disp 'real measurement made.';

