
% noise settings for environment
% true process noise
problem.env.process.noise.value = [0, 0, 0]; % zero-mean
problem.env.process.noise.uncert = [1^2, 0, 0; 0, 1^2, 0; 0,0,0.01^2]; % covariance

% true measurement noise
problem.env.meas.noise.value = [0;0;0];
problem.env.meas.noise.uncert = [0.5^2,0,0; 0,0.5^2,0 ; 0,0,0.01^2];

 

% KF process noise
problem.model.process.noise.value = [0; 0; 0]; % zero mean noise
problem.model.process.noise.uncert = [0.5*1^2, 0, 0; 0, 0.5*1^2, 0; 0,0,0.009^2];   % with some independent noise


% KF measurement noise
problem.model.meas.noise.value = [0; 0; 0];
problem.model.meas.noise.uncert = [0.5^2, 0,0; 0,0.5^2,0; 0,0,0.01^2];



% initial true state and uncertainty
problem.env.state.value = [100; 100; 0]; % latest step result
problem.env.state.uncert = [100000^2, 0,0; 0,100000^2,0; 0,0,6000^2]; 

% initial KF state and uncertainty
problem.model.state_est.value = problem.env.state.value +[100;100;0.4];  
problem.model.state_est.uncert = problem.env.state.uncert; 


% initialize multi-belief..
problem.model.state_belief(1) = problem.model.state_est;

% threshold for keeping belief states
problem.model.belief_thres = [15;15;3];


% make the world
make_world;

% set up the control parameters
global control_para;
control_para.straight_steps = 0;
control_para.length = 1500;
control_para.distance_step_size = 30;
control_para.turn_step_size = 0.25*2*pi;

global one_lm_meas_para;
one_lm_meas_para.max_dist = 120;

global meas_counter;
meas_counter = 0;


global show_printing;
show_printing = 0;

global uniform;
uniform = 1;

% how many steps?
steps = 100

% create world
make_world