function [x_post, C_x_post, K, z_hat, C_z_hat, z_res, C_res] = ekfx_meas_update_step(prob, true_z)
% incorporates measurement of which
   
    
    % extract parameters and Jacobians etc from model
    [h n para J] = get_model_settings(prob, prob.model.meas);
   
    
    % assuming the first argument is the old state (!)
    C_x_prior = para(1).uncert;
    x_prior = para(1).value;
    
    
    % get last made real measurement 
    [z] = true_z.value;
    
 
        
    % make measurement prediction
    [z_hat] = feval(h, para(:).value);
    
    
    % calculate measurement residual
    [z_res] = z - z_hat;
    
    
    % calculate uncertainty in redidual
    % this is noise in prediction plus measurement
    for i=1:n,
        C_tmp(i).influence = J(i).m*para(i).uncert*(J(i).m');
    end;
        
    C_res = C_tmp(1).influence;
    if n>1, for i=2:n, C_res = C_res + C_tmp(i).influence; end; end;
    

    % the uncertainty in the prediction is the uncertainty in residual..
    C_z_hat = C_res;
    
    % ready for updates...
     
    % calculate Kalman gain   
    if rcond(inv(C_res)) < 6.096580e-18,
        disp 'Inverse warning!' ;
        
   %     pause;
    end;
    
    K = (C_x_prior*((J(1).m)'))*( inv(C_res) );
    
    
    % update state
    x_post = x_prior + K*z_res;
    
    % and uncertainty
    C_x_post = C_x_prior - K*(J(1).m)*C_x_prior;

    % done.
    pr 'ekf measurement update performed.';

