function [x_real_to] = track_drive_process_step(x_real_from, real_control_input)
% performs a 'real' step

    Q_real = [0.0 0;0 0];
    
    % x_real_from is expected to be [x v]'
    % control_input is expected to be [delta v]
    
    % update pure process, without control_input
    
    % new state is previous plus speed per step
    x_real_to(1,1) = x_real_from(1,1) + x_real_from(2,1);
    % speed doesn't change
    x_real_to(2,1) = x_real_from(2,1);
    
    % unless there is control_input:
    x_real_to(2,1) = x_real_to(2,1) + real_control_input(1,1);
    
    % add real Gaussian process noise
    [m n] = size(x_real_from);
    for i=1:m, x_real_to(i) = x_real_to(i,1) + sqrt(Q_real(i,i))*randn; end;
    
        
    %disp 'real process step made.';

   