
function [problem, x_prior, c_x_prior, x_post, c_x_post] = make_lkf_step(problem)

    % given a problem model, estimates the state using 
    % the Linear Kalman Filter equations

    % start ekf with time update
    pr 'perform lkf time update';

   
    % execute time update
    [x_prior c_x_prior] = lkf_time_update_step(problem);

    % and save the result
    problem.model.state_est.value = x_prior;
    problem.model.state_est.uncert = c_x_prior;

    % and result to ui
    display_info(problem);


    % next, perform the measurement update
    pr 'perform lkf measurement update';

    % execute measurement update
    [x_post c_x_post] = lkf_meas_update_step(problem);

    % and save the result
    problem.model.state_est.value = x_post;
    problem.model.state_est.uncert = c_x_post;

    % and result to ui
    display_info(problem);
    
    % ekf is done
    pr 'lkf step performed.';
