function [f, n, para, J] = get_model_settings(prob, model)
% extracts data from problem model, for easier access by calling functions

    % get function
    f = model.function;
    
    
    [para paras n] = paras2string(prob, model);
    
    % make Jacobians creation commands for every parameter
    for i=1:n,
        %cmd(i).str = strcat('J(', num2str(i),').m = feval(model.para(', num2str(i), ').trans_matrix_func', paras,');');
    
        if n==1,
            J(i).m = feval(model.para(i).trans_matrix_func, para(1));
        elseif n==2,
            J(i).m = feval(model.para(i).trans_matrix_func, para(1), para(2));
        elseif n==3,
            J(i).m = feval(model.para(i).trans_matrix_func, para(1), para(2), para(3));
        elseif n==4,
            J(i).m = feval(model.para(i).trans_matrix_func, para(1), para(2), para(3), para(4));
        else
            disp 'need help in get_model_settings.m!:)';
            pause;
        end;

    end;
    
    
    % create the Jacobians (or transfer matrices)
    %for i=1:n,  
    %    eval(cmd(i).str);
    %end;
    