function [H] = diff_drive_one_lm_meas_function_Jacobian_x(x,lm,w)
% returns Jacobian with partial derivatives w.r.t x, given x, lm, w
    
    H(1,1) = -cos(x.value(3,1)); % dhx/dxx
    H(1,2) = -sin(x.value(3,1)); % dhx/dxv
    H(1,3) = -((lm.value(1,1)-x.value(1,1))*sin(x.value(3,1))) + (lm.value(2,1)-x.value(2,1))*cos(x.value(3,1)) ;
    H(2,1) = sin(x.value(3,1)); % dhv/dxx
    H(2,2) = -cos(x.value(3,1)); % dhv/dxv
    H(2,3) = (x.value(1,1)-lm.value(1,1))*cos(x.value(3,1)) - ((lm.value(2,1)-x.value(2,1))*sin(x.value(3,1)));
    H(3,1) = 0;
    H(3,2) = 0;
    H(3,3) = 1;
      
    pr 'measurement Jacobian wrt x made.';

