
function [problem, x_prior, c_x_prior, x_post, c_x_post, K, z_hat, C_z_hat, z_res, C_res] = make_ekf_step(problem)

    % given a problem model, estimates the state using 
    % the Linear Kalman Filter equations

    % start ekf with time update
    pr 'perform ekf time update';

   
    % execute time update
    [x_prior c_x_prior] = ekf_time_update_step(problem);

    % and save the result
    problem.model.state_est.value = x_prior;
    problem.model.state_est.uncert = c_x_prior;

    % and result to ui
    display_info(problem);


    % next, perform the measurement update
    pr 'perform ekf measurement update';

    % execute measurement update
    [x_post c_x_post K z_hat C_z_hat z_res C_res] = ekf_meas_update_step(problem);

    % and save the result
    problem.model.state_est.value = x_post;
    problem.model.state_est.uncert = c_x_post;

    % and result to ui
    display_info(problem);
    
    % ekf is done
    pr 'ekf step performed.';
