
function [problem, x_prior, c_x_prior, x_post, c_x_post, K] = make_iekf_step(problem)

    % given a problem model, estimates the state using 
    % the Iteratex Extended Kalman Filter equations

    % start iekf with time update
    pr 'perform iekf time update';

   
    % execute time update
    [x_prior c_x_prior] = iekf_time_update_step(problem);

    % and save the result
    problem.model.state_est.value = x_prior;
    problem.model.state_est.uncert = c_x_prior;

    % and result to ui
    display_info(problem);


    % next, perform the measurement update
    pr 'perform iekf measurement update';

    % execute measurement update
    [x_post c_x_post K] = iekf_meas_update_step(problem);

    % and save the result
    problem.model.state_est.value = x_post;
    problem.model.state_est.uncert = c_x_post;

    % and result to ui
    display_info(problem);
    
    % ekf is done
    pr 'iekf step performed.';
