function [x, z, x_hats_pri, x_hats_post, c_x_hats_pri, c_x_hats_post, z_hats] = track_drive(nr_of_steps, Q, Q_real, R, R_real)

    disp 'simulating a robot driving on a track';
    
    % number of steps to run EKF
    %nr_of_steps = 2000;
    
    
    % problem specific
    state_size = 2;
    feature_size = 2;
    
    
    % initialize tables to save data in
    x = zeros(nr_of_steps, state_size);
    z = zeros(nr_of_steps, feature_size);
    
    x_hats_pri = zeros(nr_of_steps, state_size);
    x_hats_post = zeros(nr_of_steps, state_size);
    
    c_x_hats_pri = zeros(nr_of_steps, state_size, state_size);
    c_x_hats_post = zeros(nr_of_steps, state_size, state_size);
    
    z_hats = zeros(nr_of_steps, feature_size);
    
    
    
    % initialize true process noise
   % Q_real = [1, 0; 0, 1];
    
    % initialize true measurement noise
   % R_real = [1, 0; 0, 2];
    
    % initialize true robot start position
    x_real(1,1) = 10;
    x_real(2,1) = 5;
    
    % initialize control input
    real_control_input = [0];
    
    % initialize EKF
  %  Q = Q_real;
  %  R = R_real;
    
    x_hat_pos = x_real;
    C_x_hat_pos = [1, 0; 0, 1];
    
    proc_func_handle = @track_drive_process_function;
    proc_func_Jac_handle = @track_drive_process_function_Jacobian_x;
 
    meas_func_handle = @track_drive_meas_function;
    meas_func_Jac_handle = @track_drive_meas_function_Jacobian_x;
    
    % start EKF loop
    step = 0;
    while step < nr_of_steps,
        
        step = step+1;
        
      
        % perform time update, taking old state, control input, proc.
        % noise, proc function and proc func jacobian generator
        [x_hat_pri, C_x_hat_pri] = ekf_time_update_step(x_hat_pos, C_x_hat_pos, real_control_input, Q, proc_func_handle, proc_func_Jac_handle);

        % get measurement
        [z_real] = track_drive_get_real_measurement(x_real, R_real);

        C_z_real = R_real;
        
        % perform measurement update, taking a priori state and
        % uncertainty, real measurement and measurement uncertainty, meas.
        % function and meas. function Jacobian generator
        [x_hat_pos, C_x_hat_pos, K, z_hat] = ekf_meas_update_step(x_hat_pri, C_x_hat_pri, z_real, C_z_real, meas_func_handle, meas_func_Jac_handle);
        
        % perform real actioon
        [x_real] = track_drive_process_step(x_real, real_control_input, Q_real);
        
        % save the data
        for i=1:state_size, 
            x(step,i) = x_real(i,1);
            z(step,i) = z_real(i,1);
            x_hats_pri(step,i) = x_hat_pri(i,1);
            x_hats_post(step,i) = x_hat_pos(i,1);
            
            for j=1:state_size,
                c_x_hats_pri(step,i,j) = C_x_hat_pri(i,j);
                c_x_hats_pos(step,i,j) = C_x_hat_pos(i,j);
            end;
            
        end;
        
        for i=1:feature_size,
           z(step,i) = z_real(i,1);
           z_hats(step,i) = z_hat(i,1);
        end;
            
        % display latest charts
   %     update_graphics(wins, dat_x_post);
        
       % disp 'press key for next step.';
       % pause;
        
    end;

   disp 'done.';
    